"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = subscribeToContext;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDisplayName = _interopRequireDefault(require("react-display-name"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function subscribeToContext(Consumer) {
  var propName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'context';
  // eslint-disable-next-line flowtype/no-weak-types
  return function HoC(Component) {
    function Subscriber(props) {
      return _react.default.createElement(Consumer, null, function (context) {
        var addProps = _defineProperty({}, propName, context);

        return _react.default.createElement(Component, _extends({
          ref: props.innerRef
        }, addProps, props));
      });
    }

    Subscriber.propTypes = {
      innerRef: _propTypes.default.func
    };
    Subscriber.defaultProps = {
      innerRef: null
    };
    Subscriber.displayName = "ContextSubscriber(".concat((0, _reactDisplayName.default)(Component), ")"); // $FlowFixMe: Need to wait for Flow to add support for React 16.3

    return _react.default.forwardRef ? _react.default.forwardRef(function (props, ref) {
      return _react.default.createElement(Subscriber, _extends({
        innerRef: ref
      }, props));
    }) : Subscriber;
  };
}